unit mpxfgen;
{
  MPXT Genre Unit
}

interface
 const         {Used for looking up genre strings to get a genre number}
  GenreLookupTableMax=147;
  GenreLookupTable: Array[0..GenreLookupTableMax] of String[22]=
   ('BLUES', 'CLASSIC ROCK','COUNTRY','DANCE','DISCO','FUNK','GRUNGE',
    'HIP-HOP','JAZZ','METAL','NEW AGE','OLDIES','OTHER','POP','R&B','RAP',
    'REGGAE','ROCK','TECHNO','INDUSTRIAL','ALTERNATIVE','SKA','DEATH METAL',
    'PRANKS','SOUNDTRACK','EURO-TECHNO','AMBIENT','TRIP-HOP','VOCAL',
    'JAZZ+FUNK','FUSION','TRANCE','CLASSICAL','INSTRUMENTAL','ACID','HOUSE',
    'GAME','SOUND CLIP','GOSPEL','NOISE','ALTERNROCK','BASS','SOUL','PUNK',
    'SPACE','MEDITATIVE','INSTRUMENTAL POP','INSTRUMENTAL ROCK','ETHNIC',
    'GOTHIC','DARKWAVE','TECHNO-INDUSTRIAL','ELECTRONIC','POP-FOLK',
    'EURODANCE','DREAM','SOUTHERN ROCK','COMEDY','CULT','GANGSTA','TOP 40',
    'CHRISTIAN RAP','POP/FUNK','JUNGLE','NATIVE AMERICAN','CABARET',
    'NEW WAVE','PSYCHADELIC','RAVE','SHOWTUNES','TRAILER','LO-FI','TRIBAL',
    'ACID PUNK','ACID JAZZ','POLKA','RETRO','MUSICAL','ROCK & ROLL',
    'HARD ROCK','FOLK','FOLK-ROCK','NATIONAL FOLK','SWING','FAST FUSION',
    'BEBOB','LATIN','REVIVAL','CELTIC','BLUEGRASS','AVANTGARDE',
    'GOTHIC ROCK','PROGESSIVE ROCK','PSYCHEDELIC ROCK','SYMPHONIC ROCK',
    'SLOW ROCK','BIG BAND','CHORUS','EASY LISTENING','ACOUSTIC','HUMOUR',
    'SPEECH','CHANSON','OPERA','CHAMBER MUSIC','SONATA','SYMPHONY',
    'BOOTY BASS','PRIMUS','PORN GROOVE','SATIRE','SLOW JAM','CLUB','TANGO',
    'SAMBA','FOLKLORE','BALLAD','POWER BALLAD','RHYTHMIC SOUL','FREESTYLE',
    'DUET','PUNK ROCK','DRUM SOLO','A CAPELLA','EURO-HOUSE','DANCE HALL',
    'GOA','DRUM & BASS','CLUB-HOUSE','HARDCORE','TERROR','INDIE','BRITPOP',
    'NEGERPUNK','POLSK PUNK','BEAT','CHRISTIAN GANGSTA RAP','HEAVY METAL',
    'BLACK METAL','CROSSOVER','CONTEMPORARY CHRISTIAN','CHRISTIAN ROCK',
    'MERENGUE','SALSA','TRASH METAL','ANIME','JPOP','SYNTHPOP');

procedure GenreSelect;
procedure define_genre;
procedure define_playoptions;
function GetGenre(sn:string):word;
function SongInGenre(sn:string):boolean;
procedure PlayOptionSelect;
implementation
uses mpxfvars,lcd,crt,config,mpxfcprc;
const selON = 2;
      selOFF = 32;


function GetGenre(sn:string):word;
  var thesong:string;
      v,c:word;
  begin
    thesong := '';
    thesong := stripend(sn);
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    val(thesong,v,c);
    GetGenre := v;
  end;

function SongInGenre(sn:string):boolean;
  var gen:char;
      s:integer;
      return:boolean;
  begin
    return := false;
    if GenreSupport then begin
      gen := chr(GetGenre(sn));
      for s := 1 to GenreTypes do begin
        if Genre[s]^.tag then begin
          if pos(gen,Genre[s]^.data) > 0 then return := true;
        end;
      end;
    end else return := true;
    SonginGenre := return;
 end;

procedure GenreEdit(var genre:genres; max:byte);
  var
    start:integer;
    info:integer;
    line1,line2:integer;
    i:integer;
    cs:string;
    ch:char;
    tag:word;
    CurrentGenre:word;
    SongTitle:string;
    SongDesc:string;
    Ppos:word;
    iReturn:integer;


    procedure UpdateGenre;
      var sn:string;
          Album:string;
          Artist:string;
          i,b,a :integer;
          CurrentChoice:byte;
          choices:byte;
      begin
        lcdclear;
        CurrentChoice := currentgenre;
        choices := max;
       if (CurrentChoice = choices) and (Choices >= LCDLines) then begin
          for i := CurrentChoice-1 downto CurrentChoice-LCDLines+1 do begin
            if (genre[i]^.tag = false) then LCDPrintAt(LCDLines-(CurrentChoice-i),' '+chr(selOFF)) else
             LCDPrintAt(LCDLines-(CurrentChoice-i),' '+chr(selON));
             LCDPrint(genre[i]^.name);
          end;

           if (genre[currentchoice]^.tag = false) then LCDPrintAt(LCDLines,'>'+chr(selOFF)+genre[CurrentChoice]^.name) else
             LCDPrintAt(LCDLines,'>'+chr(selON)+genre[CurrentChoice]^.name);

       end else
       if ((Choices-CurrentChoice) < LCDLines-1) and (Choices>=LCDLines) then begin
         b := choices-currentchoice;
         a := lcdlines - b;
         for i := 1 to a-1 do begin
            if (genre[Choices-lcdlines+i]^.tag = false) then LCDPrintAt(i,' '+chr(selOFF)) else
             LCDPrintAt(i,' '+chr(selON));
             LCDPrint(genre[Choices-lcdlines+i]^.name);
         end;

        if (genre[CurrentChoice]^.tag = false) then LCDPrintAt(a,'>'+chr(selOFF)+genre[CurrentChoice]^.name) else
             LCDPrintAt(a,'>'+chr(selON)+genre[CurrentChoice]^.name);
         for i := a+1 to LCDLines do begin
           if (genre[Choices-lcdlines+i]^.tag = false) then LCDPrintAt(i,' '+chr(selOFF)) else
             LCDPrintAt(i,' '+chr(selON));
             LCDPrint(genre[Choices-lcdlines+i]^.name);
         end;
       end else
       begin
          if genre[CurrentChoice]^.tag = false then LCDPrintAt(1,'>'+chr(selOFF)+genre[CurrentChoice]^.name) else
             LCDPrintAt(1,'>'+chr(selON)+genre[CurrentChoice]^.name);
          for i := 2 to LCDLines do
            if ((i-1+currentchoice)<=choices) then
            begin
              if ((i-1+currentchoice)<=choices) then
              if (genre[CurrentChoice+i-1]^.tag = false) then LCDPrintAt(i,' '+chr(selOFF)) else
               LCDPrintAt(i,' '+chr(selON));
                LCDPrint(genre[CurrentChoice+i-1]^.name);
            end
            else
              LCDPrintAt(i,spaces(LCDLen));
       end;
      end;

    procedure UpdateGenre2;
      var sn:string;
          Album:string;
          Artist:string;
          i :integer;
      begin
        LCDClear;
        LCDPrintAt(1,'>');
        if (genre[CurrentGenre]^.tag = false) then LCDPrint(chr(219)) else
          LCDPrint(chr(255));
        LCDPrint(genre[CurrentGenre]^.name);
        if CurrentGenre = GenreTypes then begin
          LCDPrintAt(2,' ');
          if (genre[1]^.tag = false) then LCDPrint(chr(219)) else LCDPrint(chr(255));
          LCDPrint(genre[1]^.name);
        end
        else
          begin
            LCDPrintAt(2,' ');
            if (genre[CurrentGenre+1]^.tag = false) then LCDPrint(chr(219)) else
              LCDPrint(chr(255));
            LCDPrint(genre[CurrentGenre+1]^.name);
          end;

        delay(20);
      end;

  begin
    LCDCursorOFF;
{    LCDtoSCreen := False;}
    Tag := 0;
    CurrentGenre:=1;
    starcount := 0;
    ch := ' ';
    UpdateGenre;
    iReturn := 0;
    ch := ' ';
    repeat
{      dostar(1);}
      ch := ' ';
      if keypress then ch:=getkey;
      if ch=chr(EnterChar) then
        begin
          Genre[CurrentGenre]^.tag := not Genre[CurrentGenre]^.tag;
          UpdateGenre;
        end;
      if ch=chr(UpChar) then
        begin
          if CurrentGenre = 1 then CurrentGenre := max else
          dec(CurrentGenre);
          UpdateGenre;
        end;
      if ch=chr(DownChar) then
        begin
          if CurrentGenre = max then CurrentGenre := 1 else
          inc(CurrentGenre);
          UpdateGenre;
        end;
       delay(10);
       drawmpxtlogo;
     until (ch=chr(ExitChar));
     save_settings;
   { // Check if user got out // }
     LCDtoSCreen := True;
   end;

procedure GenreSelect;
  begin
    GenreEdit(genre,genretypes);
  end;

procedure PlayOptionSelect;
  begin
     GenreEdit(playoptions,numplayoptions);
  end;

{MPXT 1.5, finally got this thing working again}
procedure define_genre;
  var {i :integer; Removed MPXT 1.5}
{      num:byte;  Removed MPXT 1.5}
      datas:string;
      cp:byte;
      genrenum:string[3]; {Changed from string; to string[3], to save memory}
      gdata,code:word;
  begin
{    genretypes := ReadWord('Genres','Genres');}
    genretypes := 0;
{    num := 1;}
{    datas := ReadString('Genres','Genre'+strr(num)+'name'); Removed MPXT 1.5}
    datas := ReadString('Genres','Genre'+strr(genretypes+1)+'name');
    while datas <> '' do
     begin
      inc(genretypes);
      new(genre[genretypes]);
      genre[genretypes]^.name := datas;
      {Bugfix MPXT 1.5, genre[genretypes]^.data wasn't initialized}
      genre[genretypes]^.data:='';
      datas := ReadString('Genres','Genre'+strr(genretypes)+'data');

{      cp := pos(',',datas);          This thing had to be rewritten a little
      while (cp > 0) do                to get it working again for MPXT
       begin
        genrenum := copy(datas,1,cp-1);
        val(genrenum,gdata,code);
        genre[i]^.data := genre[i]^.data + chr(gdata);
        datas := copy(datas,cp+1,length(datas);
        cp := pos(',',datas);
        if ((cp=0) and (length(datas) > 0)) then cp := length(datas)+1;
       end;}

      if datas[length(datas)]<>',' then  {This may look like a cheezy hack}
       datas:=datas+',';                  {but it makes this routine without}
      cp := pos(',',datas);               {work without adding an extra}
      while (cp > 1) do                   {compare inside the loop}
       begin
        genrenum := copy(datas,1,cp-1);  {Get the data thats before the comma}
        val(genrenum,gdata,code);
        genre[genretypes]^.data := genre[genretypes]^.data + chr(gdata);
        datas := copy(datas,cp+1,length(datas)-cp); {Remove data before comma}
        cp := pos(',',datas);
       end;

      genre[genretypes]^.tag := true;
{      inc(num);}                        {Removed MPXT 1.5}
{      datas := ReadString('Genres','Genre'+strr(num)+'name');}
      datas := ReadString('Genres','Genre'+strr(genretypes+1)+'name');
     end;




{    for i := 1 to genretypes do begin
      num:=strr(i);
      new(genre[i]);
      genre[i]^.name := ReadString('Genres','Genre'+num+'name');
      genre[i]^.data := '';
      datas := ReadString('Genres','Genre'+num+'data');
      cp := pos(',',datas);
      while (cp > 0) do begin
        genrenum := copy(datas,1,cp-1);
        val(genrenum,gdata,code);
        genre[i]^.data := genre[i]^.data + chr(gdata);
        datas := copy(datas,cp+1,length(datas));
        cp := pos(',',datas);
        if ((cp=0) and (length(datas) > 0)) then cp := length(datas)+1;
      end;
      genre[i]^.tag := true;
    end;}
  end;

procedure define_playoptions;
  var i :integer;
      num:byte;
      datas:string;
      cp:byte;
      genrenum:string;
      gdata,code:word;
  begin
 {   numplayoptions := ReadWord('Play Options','Options');}

    num := 1;
    datas := ReadString('Play Options','Option'+strr(num)+'name');
    while datas <> '' do begin
      inc(numplayoptions);
      new(playoptions[numplayoptions]);
      playoptions[numplayoptions]^.name := datas;
      datas := ReadString('Play Options','Option'+strr(numplayoptions)+'data');
      playoptions[numplayoptions]^.data := datas;
      playoptions[numplayoptions]^.tag := false;
      inc(num);
      datas := ReadString('Play Options','Option'+strr(num)+'name');
    end;
  end;

begin
end.
