program MPXFTSR;
{ 32192,0,0 }

{$M 10240,0,4000}

uses dos,mpxftsrb;

Var
 MyStackSeg, MyStackPtr : Word;         {Points to the TSR's stack}
 OldStackSeg, OldStackPtr : Word;       {Points to the forground apps's stack}
 Old1Cint:Procedure;                    {Points to the old 1C interrupt}


{$F+}                                   {Fixes the stack overflow error, by}
Procedure MyInt1C;Interrupt;             {using a stack dedicated to this TSR}
 Begin
  asm cli end;                          {Disable Interrupts}
  OldStackSeg:=SSeg;                    {Save the location of the forground}
  OldStackPtr:=SPtr;                     {app's stack}
  asm
   mov SS,MyStackSeg                    {Switch over to the TSR's stack}
   mov SP,MyStackPtr
   sti                                  {Enable Interrupts}
  end;                                  {Done with the stack swap}

  MainTSRProc;                          {Call the main TSR procedure}

  asm
   cli                                  {Disable Interrupts}
   mov SS,OldStackSeg                   {Switch back to the foreground app's}
   mov SP,OldStackPtr                    {stack}
   sti                                  {Enable Interrupts}
  end;

  Inline($9C);                          {Pushf - Push Flags}
  Old1Cint;                             {Call the old Int 1C Procedure}
 End;
{$F-}

begin
  doit;

  Asm CLI End;
  MyStackSeg:=SSeg;                     {Save the TSR's stack location}
  MyStackPtr:=SPtr;                      {so we can use it later}
  Asm STI End;

  Getintvec($1C ,@Old1Cint);            {Save the location old Int1C function}
  Setintvec($1C ,@MyInt1C);             {Make Int1C point to MyInt1C function}

  Keep(0);                              {Terminate And Stay Resident - TSR}
end.

